package com.bergerkiller.bukkit.nolagg;

import org.bukkit.event.Event;
import org.bukkit.event.world.ChunkLoadEvent;
import org.bukkit.event.world.ChunkPopulateEvent;
import org.bukkit.event.world.ChunkUnloadEvent;
import org.bukkit.event.world.WorldListener;
import org.bukkit.event.world.WorldLoadEvent;
import org.bukkit.event.world.WorldUnloadEvent;

import com.all.bukkit.threadcheck.ThreadCheck;
import com.bergerkiller.bukkit.nolagg.ChunkOperation.Type;
import com.bergerkiller.bukkit.nolagg.meta.ChunkMetaData;
import com.bergerkiller.bukkit.nolagg.meta.WorldMetaData;

public class NLWorldListener extends WorldListener {

	public static long loadedChunks = 0;
	public static long genChunks = 0;
	
	@Override
	public void onChunkLoad(ChunkLoadEvent event) {
		if (!ThreadCheck.check(Event.Type.CUSTOM_EVENT)) return;
		ChunkMetaData data = ChunkMetaData.get(event.getChunk());
		data.touch();
		data.update();
		loadedChunks++;
	}
	
	@Override
	public void onChunkUnload(ChunkUnloadEvent event) {
		if (!ThreadCheck.check(Event.Type.CUSTOM_EVENT)) return;
		ChunkMetaData data = ChunkMetaData.get(event.getChunk());
		if (!data.isUnloadable() || !data.isExpired() || data.isPlayerNear()) {
			event.setCancelled(true);
			data.touch();
			data.update();
		}
	}
		
	@Override
	public void onWorldLoad(WorldLoadEvent event) {
		if (!ThreadCheck.check(Event.Type.CUSTOM_EVENT)) return;
		WorldMetaData.get(event.getWorld());
		AutoSaveChanger.change(event.getWorld());
	}
	
	@Override
	public void onWorldUnload(WorldUnloadEvent event) {
		if (!ThreadCheck.check(Event.Type.CUSTOM_EVENT)) return;
		WorldMetaData.remove(event.getWorld());
	}
	
	@Override
	public void onChunkPopulate(ChunkPopulateEvent event) {
		ChunkScheduler.schedule(event, Type.LIGHTING);
		genChunks++;
	}

	
}
